/* set.h  DS  2/3/93 */

/*
 * 
 * header file for the abstract data type  INT_SET
 * 
 */

#ifndef INT_SET_H
#define INT_SET_H

#ifndef NULL
#define NULL 0
#endif

#ifndef TRUE
#define TRUE 1
#endif

#ifndef FALSE
#define FALSE 0
#endif

#ifndef BOOLEAN
#define BOOLEAN int
#endif

#define SMAX 40000

struct element {
  int		 value;
  struct element *next;
};

extern struct element elements[SMAX];

typedef struct element *INT_SET;

#define NULLSET	((INT_SET)NULL)
#define VAL(e)  ((e) -> value)
#define NEXT(e) ((e) -> next)
  
extern void init_INT_SET(void);
extern INT_SET add(int v, INT_SET s);
extern INT_SET add_unique(int v, INT_SET s);
extern INT_SET delete(INT_SET s);

#endif
